;--------------------------------------------------------------------------------
;	PIC16F887EԑvEdv v7 Programmed by GRANADA
;	Ver 0.9		2011/01/12 ` 2011/01/13	Speed_Meter5 x[Xɉ
;											   CCP2n[hEGA PWM fB}[ALED 6 4 ubN\
;	Ver 1.0		2011/01/14					16 K\tgEGA PWM fB}[ALED 8 3 ubN\
;	Ver 1.1		2011/01/17					PWM  32 KɕύX
;
;	LF http://www.asahi-net.or.jp/~SE1M-NITU/html/Speed_Meter7.htm
;--------------------------------------------------------------------------------

	LIST		P=16F887
	INCLUDE		P16F887.INC
	INCLUDE		Original_Macro.lib

	ERRORLEVEL	-205
	ERRORLEVEL	-302

    __CONFIG    _CONFIG1, _DEBUG_OFF & _LVP_OFF & _FCMEN_ON & _IESO_OFF & _BOR_ON & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
    __CONFIG    _CONFIG2, _WRT_OFF & _BOR40V

;--------------------------------------------------------------------------------
;	ϐAhX`
;--------------------------------------------------------------------------------

CBLOCK	H'20'			; [U[pt@CWX^iϐ̈j擪AhX

	TMR1_CNT_H			; Lv` TMR1 JEgl
	TMR1_CNT_L

	SPEED				; Xs[hi10iǒl Km/hj
	PREV_SPEED			; ÕXs[h

	LED					; _ LED 

	BCD_H				; BCD ϊl
	BCD_M				; BCD ϊl
	BCD_L				; BCD ϊl

	PATTERN_H			; ʃrbgp^[E}X^[p^[
	PATTERN_M			; ʃrbgp^[E}X^[p^[
	PATTERN_L			; ʃrbgp^[E}X^[p^[

	SEGMENT				; \rbgp^[

	SP_FACTOR			; \x␳pt@N^[

	ILLEGULAR			; CM[lopJE^

	BL_CNT				; ԌopJE^
	DK_CNT				; ÏԌopJE^

	BLIGHTNESS			; PWM K (l: 1 ` Kől)
	PWM_ON				; Kp
	PWM_OFF				; Kp

	USER_FLAG			; etO

ENDC

CBLOCK	H'70'			; SoNʃt@CWX^擪AhX

	W_WORK				; 荞ݎ W WX^ޔp
	ST_WORK				; 荞ݎ̃Xe[^XWX^ޔp

	COUNTER1			; ԑ҂p
	COUNTER2			; ԑ҂p
	COUNTER3			; ԑ҂p

ENDC

;--------------------------------------------------------------------------------
;	萔`, DEFINE g MPLAB SIM ̃t@CWX^_vɕ֗
;	it@CWX^ɒ萔ꍞ܂Ȃj
;--------------------------------------------------------------------------------

#DEFINE		FACTOR_H		H'13'	; &H1312d0 = 1250000
#DEFINE		FACTOR_M		H'12'	; 4 pXԈȊOȂ炱ύX
#DEFINE		FACTOR_L		H'D0'	; e.g. 2 pXԂȂ{A8pXԂȂ甼

#DEFINE		LED_MAX			D'24'	; Ăo[ LED ̌

#DEFINE		SPEED_QUALITY	D'15'	; (Km/h) 1 pXłȏ̕ωꍇ̓f[^𖳎
#DEFINE		ILLEGULAR_TH	D'10'	; ACM[l琳lƂăf[^XV邩

#DEFINE		DUTY_MAX		D'32'	; \Kől

#DEFINE		RESPONSE		D'2'	; ÏԔqXeVXԁA\ 15.36ms x RESPONSE = 30.72ms
									; Pxő̋Pxŏ܂ 30.72ms x 32iKj = 983.04ms

									;     (2.0V) 300 =  6.6mA
									;     (1.5V) 470 =  3.2mA
									;     (2.0V) 470 =  4.2mA
									;     (2.0V) 150 = 13.0mA
									;     (3.0V) 300 = 10.0mA
									; 7ZO (0.6V)  22 = 27.0mA

;--------------------------------------------------------------------------------
;	|[g`
;--------------------------------------------------------------------------------

#DEFINE		DIMMER_PORT	PORTE,3			; 邳op|[g`AL = 

#DEFINE		C1_PORT		PORTA,1			; 7 ZO LED 1ڐ|[g`
#DEFINE		C2_PORT		PORTA,0			; 7 ZO LED 2ڐ|[g`
#DEFINE		C3_PORT		PORTB,7			; 7 ZO LED 3ڐ|[g`

#DEFINE		A_SEG		PORTB,0			; 7 ZO LED a ZOg̃|[gԍ
#DEFINE		B_SEG		PORTB,1			; 7 ZO LED b ZOg̃|[gԍ
#DEFINE		C_SEG		PORTB,2			; 7 ZO LED c ZOg̃|[gԍ
#DEFINE		D_SEG		PORTB,3			; 7 ZO LED d ZOg̃|[gԍ
#DEFINE		E_SEG		PORTB,4			; 7 ZO LED e ZOg̃|[gԍ
#DEFINE		F_SEG		PORTB,5			; 7 ZO LED f ZOg̃|[gԍ
#DEFINE		G_SEG		PORTB,6			; 7 ZO LED g ZOg̃|[gԍ

#DEFINE		LED01_PORT	PORTD,7			; o[ LED |[g`
#DEFINE		LED02_PORT	PORTA,2
#DEFINE		LED03_PORT	PORTA,3
#DEFINE		LED04_PORT	PORTA,4
#DEFINE		LED05_PORT	PORTA,5
#DEFINE		LED06_PORT	PORTE,0
#DEFINE		LED07_PORT	PORTE,1
#DEFINE		LED08_PORT	PORTE,2
#DEFINE		LED09_PORT	PORTD,6
#DEFINE		LED10_PORT	PORTD,5
#DEFINE		LED11_PORT	PORTA,7
#DEFINE		LED12_PORT	PORTA,6
#DEFINE		LED13_PORT	PORTC,0
#DEFINE		LED14_PORT	PORTC,1
#DEFINE		LED15_PORT	PORTD,4
#DEFINE		LED16_PORT	PORTC,3
#DEFINE		LED17_PORT	PORTD,0
#DEFINE		LED18_PORT	PORTD,1
#DEFINE		LED19_PORT	PORTC,7
#DEFINE		LED20_PORT	PORTC,6
#DEFINE		LED21_PORT	PORTC,5
#DEFINE		LED22_PORT	PORTC,4
#DEFINE		LED23_PORT	PORTD,3
#DEFINE		LED24_PORT	PORTD,2

#DEFINE		TMR1_OF		USER_FLAG,0		; 1 = TMR1 I[o[t[
#DEFINE		DISP_MODE	USER_FLAG,1		; 1 = HUD \, 0 = m[}\
#DEFINE		PWM_MAX		USER_FLAG,2		; 1 = őPx

;--------------------------------------------------------------------------------
;	vO擪
;--------------------------------------------------------------------------------

	ORG		H'0'
	GOTO	INITIALIZE

;--------------------------------------------------------------------------------
;	荞ݏ
;--------------------------------------------------------------------------------

	ORG		H'4'			; 荞ݏ擪AhX

	MOVWF	W_WORK			; WX^Ҕ
	SWAPF	STATUS,W		; Z tOeȂ悤AMOVF ł͂Ȃ SWAPF gp
	MOVWF	ST_WORK			; STATUS WX^ۑ Bank A\

;
;	Lv` ?
;

	BANKSEL	PORTA			; m Bank 0 ցiK{j

CHK_CAPTURE:

	BTFSS	PIR1,CCP1IF		; Bank0
	GOTO	CHK_TMR1_OVERF	; TMR1 over flow `FbN

	CLRF	TMR1L			; Bank0, TMR1 NAĎ̑ɔ
	CLRF	TMR1H			; Bank0

	BCF		PIR1,CCP1IF		; ݌tONA

	BTFSC	TMR1_OF			; 0 = TMR1 Over Flow ̃pXł͂ȂƂmF
	GOTO	CAPTURE2		; TMR1 Over Flow ̃pXł͎gvZłȂ̂Œl͕ۑȂ

	MOVF	CCPR1H,W		; Bank0, TMR1 JE^lۑ
	MOVWF	TMR1_CNT_H
	MOVF	CCPR1L,W		; Bank0
	MOVWF	TMR1_CNT_L

CAPTURE2:

	BCF		TMR1_OF			; Over Flow tONA

	GOTO	POP_REG			; Lv`݂ TMR1 I[o[t[͓ɂ͂蓾Ȃ̂Ŋ荞݂I

;
;	TMR1 I[o[t[ ?
;

CHK_TMR1_OVERF:				; iTMR1 ͎I 0 ăJEgAbvJnj

	BTFSS	PIR1,TMR1IF		; TMR1 over flow ?
	GOTO	POP_REG			; No

	BCF		PIR1,TMR1IF		; ݌tONA

	CLRF	TMR1_CNT_H		; K莞ԓɃpX̂ŃJE^lNA
	CLRF	TMR1_CNT_L

	BSF		TMR1_OF			; Over Flow tO𗧂ĂĂi̒̃pX̎gvZhj

;
;	ݏI
;

POP_REG:					; WX^A`荞ݏI

	SWAPF	ST_WORK,W
	MOVWF	STATUS
	SWAPF	W_WORK,F
	SWAPF	W_WORK,W

	RETFIE					; 荞ݏI

;--------------------------------------------------------------------------------
;	1̐7ZOgrbgp^[Ԃ
;--------------------------------------------------------------------------------

GET_7SEG_PATTERN:				;	ʏ\p

	ADDWF	PCL,F
;              gfedcba
	RETLW	B'00111111'	;	0
	RETLW	B'00000110'	;	1
	RETLW	B'01011011'	;	2
	RETLW	B'01001111'	;	3
	RETLW	B'01100110'	;	4
	RETLW	B'01101101'	;	5
	RETLW	B'01111101'	;	6
	RETLW	B'00100111'	;	7
	RETLW	B'01111111'	;	8
	RETLW	B'01101111'	;	9

GET_7SEG_PATTERN_HUD:			;	HUD \p

	ADDWF	PCL,F
;              gfedcba
	RETLW	B'00111111'	;	0
	RETLW	B'00110000'	;	1
	RETLW	B'01101101'	;	2
	RETLW	B'01111001'	;	3
	RETLW	B'01110010'	;	4
	RETLW	B'01011011'	;	5
	RETLW	B'01011111'	;	6
	RETLW	B'00110011'	;	7
	RETLW	B'01111111'	;	8
	RETLW	B'01111011'	;	9

;--------------------------------------------------------------------------------
; Le[u̓AZuAhX 100ԒnɎ߂邱ƁI
;--------------------------------------------------------------------------------

;--------------------------------------------------------------------------------
;	vOX^[g
;--------------------------------------------------------------------------------

INITIALIZE:

;---------------------------------------------------------------------------
;	o̓WX^ݒ
;---------------------------------------------------------------------------

	CALL	CLR_ALL_LED

	BANK1

	CLRF	TRISA			; Bank 1, ЂƂ܂S|[go͂Ɏw
	CLRF	TRISB			; Bank 1
	CLRF	TRISC			; Bank 1
	CLRF	TRISD			; Bank 1
	CLRF	TRISE			; Bank 1
	BSF		TRISC,2			; Bank 1, CCP1 |[g͂

	MOVLW	B'01100001'		; NbN 4MHz ɐݒ
	MOVWF	OSCCON			; Bank 1

	BANK3

	CLRF	ANSEL			; Bank 3, S|[gfW^ݒ
	CLRF	ANSELH			; Bank 3

;--------------------------------------------------------------------------------
;	TMR1 ݒ, Lv`@\ݒ
;--------------------------------------------------------------------------------

	BANK0

	MOVLW	B'00000101'		; Capture mode with rising edge
	MOVWF	CCP1CON			; Bank0

	CLRF	TMR1H			; Bank0, TMR1 NA
	CLRF	TMR1L			; Bank0

	MOVLW	B'00110100'		; vXP[ 1:8 -> 65536 x 8 x 1(us) = ő 524ms ܂ŎԑpX҂
	MOVWF	T1CON			; Bank0

;--------------------------------------------------------------------------------
;	̑ݒ (Bank0)
;--------------------------------------------------------------------------------

	CALL	CLR_ALL_LED

	CALL	WAIT_1sec_4MHz
	CALL	WAIT_1sec_4MHz	; ҂ċNi˓d΍j

	CALL	START_UP		; X^[gAbvf

	CALL	CLR_ILLE_CNT	; CM[lJE^NA
	CALL	RESET_BL_CNT	; opJE^
	CALL	RESET_DK_CNT	; ÌopJE^

	CLRF	TMR1_CNT_H
	CLRF	TMR1_CNT_L

	CLRF	LED

	CLRF	SPEED
	MOVLW	D'1'
	MOVWF	PREV_SPEED		; NɃf[^\邽߂̍׍H

	CLRF	USER_FLAG		; etO
	BSF		TMR1_OF			; Over Flow tOZbgiŏ̃pX̎̓AeɂȂȂj
	NOP
	BSF		DISP_MODE		; 1 = HUDAm[}\Ȃ炱̍s폜

	CLRF	PATTERN_H		; uN\ŃX^[g
	CLRF	PATTERN_M
	CLRF	PATTERN_L

	MOVLW	DUTY_MAX		; őPxŃX^[g
	MOVWF	BLIGHTNESS

;--------------------------------------------------------------------------------
;	\vZ␳t@N^[ݒ
;-------------------------------------------------------------------------------

	MOVLW	H'DC'			; |[g H = ␳ &H05DC = 1500 (16bit)AJIS ʂ̕␳ &H0584
	MOVWF	SP_FACTOR

;--------------------------------------------------------------------------------
;	ݏJn
;--------------------------------------------------------------------------------

	BSF		INTCON,GIE		; Bank0, S̊荞݋
	NOP
	BSF		INTCON,PEIE		; Bank0, ӊ (e.g. TMR1) 
	NOP

	BANK1

	BSF		PIE1,TMR1IE		; Bank1, TMR1 over flow ݋
	BSF		PIE1,CCP1IE		; Bank1, Lv`݋

	BANK0

	BSF		T1CON, TMR1ON	; Bank 0, TMR1 X^[g

;--------------------------------------------------------------------------------
;	C[vJn
;--------------------------------------------------------------------------------

MAIN_LOOP:

	CALL	CONV_DATA		; g  x (SPEED)

;
;	xωʃ`FbNACM[l͈񐔂܂Ŗ
;

	MOVF	PREV_SPEED,W
	SUBWF	SPEED,W			; SPEED - PREV_SPEED(W) -> Wiωʁj
	BTFSC	STATUS,Z
	GOTO	UPDATE			; Z-1, xω[hؑ֎lĕ\͍XVACM[JE^̓Zbg

	BTFSC	STATUS,C		; if SPEED < PREV_SPEED, C=0 Ŏ؂ꔭ
	GOTO	SPEED_UP		; ؂ꂪȂ  W = ̒lł̂܂

;
;	
;

SPEED_DOWN:

	MOVF	SPEED,W			; ωʂɂȂ悤ZȂ
	SUBWF	PREV_SPEED,W	; PREV_SPEED - SPEED -> Wiωʁj

;
;	
;

SPEED_UP:

	SUBLW	SPEED_QUALITY	; Mۏl - Wiωʁj-> W
	BTFSC	STATUS,C		; if Mۏl < W, C=0
	GOTO	UPDATE			; Xs[hωMۏlȓȂ̂Ńf[^𐳏XV

	DECFSZ	ILLEGULAR,F		; ACM[l`FbN
	GOTO	ILLEGULAR_SPEED

;
;	񐔘AăCM[l
;

	GOTO	UPDATE			; łȂ̂Őf[^Ƃĕ\XV

;
;	񐔈ȉ̃CM[l̏ꍇ
;

ILLEGULAR_SPEED:

	MOVF	PREV_SPEED,W
	MOVWF	SPEED			; xÕf[^ɏC

	GOTO	EXEC_DISPLAY2	; \lωAJE^̓ZbgȂ

;
;	f[^Abvf[g
;

UPDATE:

	MOVF	SPEED,W
	MOVWF	PREV_SPEED		; ̕ω`FbN̂ߌ݂̃Xs[hlۑ

EXEC_DISPLAY:

	CALL	CLR_ILLE_CNT	; CM[lJE^Zbg

EXEC_DISPLAY2:

	CALL	CHECK_DIMMER	; 邳`FbN`Kݒ

	CALL	CALC_BAR		; _ LED vZ
	CALL	BAR_DISPLAY		; o[\

	CALL	SET_PARAMETERS	; LED _vZA7ZOp^[Zbg
	CALL	DISPLAY			; 7ZO\

	GOTO	MAIN_LOOP

;--------------------------------------------------------------------------------
;	ȉTu[`Q
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;	LED \
;	IN		SPEED			xi10iǒl, Km/hj
;	RETURN	LED				_
;--------------------------------------------------------------------------------

CALC_BAR:

	MOVF	SPEED,W
	MOVWF	A1				; q

	MOVLW	D'5'			; 5Km/h 
	MOVWF	B1				; 

	CALL	DIV8			; in Math24_v2.lib, returns A1ij, B1i]j
;
;	23
;
	MOVLW	D'3'
	SUBWF	B1,W			; B1i]j - 3 -> W
	BTFSC	STATUS,C		; if ] < 3, C=0
	INCF	A1,F			; ]肪3ȏȂ_悹

	MOVF	A1,W			; ǂݏo
	MOVWF	LED				; _ LED ̌֕ۑ
;
;	NbsO
;
	MOVLW	LED_MAX
	SUBWF	LED,W			; LED - LED  -> W
	BTFSS	STATUS,C		; if LED >= LED , C=1
	RETURN

	MOVLW	LED_MAX
	MOVWF	LED				;  LED ȏȂ␳

	RETURN

;--------------------------------------------------------------------------------
;	LED \ZOgp^[𓾂
;	IN		SPEED			xi10iǒl, Km/hj
;	RETURN	PATTERN_H		ʂ̃ZOgp^[
;			PATTERN_M		ʂ̃ZOgp^[
;			PATTERN_L		ʂ̃ZOgp^[
;--------------------------------------------------------------------------------

SET_PARAMETERS:

	CLRF	prm1b			;  8bit ̓NA
	MOVF	SPEED,W			; 10iǒl͉ 8bit
	MOVWF	prm1a			; ʃZbg

	CALL	HEX2DEC16		; 16bitl -> 5 BCD ϊ

	MOVF	prm3a,W			; BCD 
	MOVWF	BCD_L			; XgA
	MOVF	prm3b,W			; BCD 
	MOVWF	BCD_M			; XgA
	MOVF	prm3c,W			; BCD 
	MOVWF	BCD_H			; XgA

;--------------------------------------------------------------------------------
;	BCD lɊÂ LED \p^[ɃZbg
;--------------------------------------------------------------------------------

	MOVF	BCD_H,W
	BTFSS	STATUS,Z			; ŏʂ0 ?
	GOTO	SET_H_PATTERN		; 0 łȂ̂Œʏ폈

	CLRF	PATTERN_H			; ŏʂ̓uN

	MOVF	BCD_M,W
	BTFSS	STATUS,Z			; 2ڂ0 ?
	GOTO	SET_M_PATTERN		; 2ڂ 0 łȂ̂Œʏ폈

	CLRF	PATTERN_M			; 2ڂuN

	GOTO	SET_L_PATTERN		; ŏI 0 ł\

SET_H_PATTERN:

	MOVF	BCD_H,W				; 100̈ʂ𓾂
	CALL	GET_PATTERN			; ϊ
	MOVWF	PATTERN_H			; p^[ۑ

SET_M_PATTERN:

	MOVF	BCD_M,W				; 10̈ʂ𓾂
	CALL	GET_PATTERN			; ϊ
	MOVWF	PATTERN_M			; p^[ۑ

SET_L_PATTERN:

	MOVF	BCD_L,W				; 1̈ʂ𓾂
	CALL	GET_PATTERN			; ϊ
	MOVWF	PATTERN_L			; p^[ۑ

	RETURN

;--------------------------------------------------------------------------------
;	7ZO\p^[𓾂iHUD\Am[}\Ήj
;	IN:		WiBCDlj
;	IN:		DISP_MODE tO
;	RETURN:	W (ZOgp^[j
;--------------------------------------------------------------------------------

GET_PATTERN:

	BTFSC	DISP_MODE			; ݒ`FbNA1 = HUD [h
	GOTO	GET_HUD_DATA

	CALL	GET_7SEG_PATTERN
	RETURN

GET_HUD_DATA:

	CALL	GET_7SEG_PATTERN_HUD
	RETURN

;--------------------------------------------------------------------------------
;	VZO LED \
;	PATTERN_H	ʌZOgp^[
;	PATTERN_M	ʌZOgp^[
;	PATTERN_L	ʌZOgp^[
;--------------------------------------------------------------------------------

DISPLAY:

	CALL	CLR_7SEG			; S

;
;	LED1 \
;

	MOVF	PATTERN_H,W			; ʌp^[ǂݏo
	MOVWF	SEGMENT

	BCF		C1_PORT				; H ON (L=_)
	CALL	DYNAMIC				; ZOgJn

;
;	LED2 \
;

	MOVF	PATTERN_M,W			; ʌp^[ǂݏo
	MOVWF	SEGMENT

	BCF		C2_PORT				; M ON (L=_)
	CALL	DYNAMIC				; ZOgJn

;
;	LED3 \
;

	MOVF	PATTERN_L,W			; ʌp^[ǂݏo
	MOVWF	SEGMENT

	BCF		C3_PORT				; L ON (L=_)
	CALL	DYNAMIC				; ZOgJn

	RETURN

;--------------------------------------------------------------------------------
;	ʏ_Ci~bN_iX^eBbN_j
;
;	IN:		SEGMENT = rbgp^[
;--------------------------------------------------------------------------------

DYNAMIC:

	BTFSC	SEGMENT,0
	BSF		A_SEG				; a ZOg_

SEG_B:

	BTFSC	SEGMENT,1
	BSF		B_SEG				; b ZOg_

SEG_C:

	BTFSC	SEGMENT,2
	BSF		C_SEG				; c ZOg_

SEG_D:

	BTFSC	SEGMENT,3
	BSF		D_SEG				; d ZOg_

SEG_E:

	BTFSC	SEGMENT,4
	BSF		E_SEG				; e ZOg_

SEG_F:

	BTFSC	SEGMENT,5
	BSF		F_SEG				; f ZOg_

SEG_G:

	BTFSC	SEGMENT,6
	BSF		G_SEG				; g ZOg_

DISP_BLANK:						; uN\̏ꍇł莞Ԃ͏

	CALL	PWM_7SEG			; \ێ ` 

	RETURN

;--------------------------------------------------------------------------------
;	o[ LED _
;	8 3ubNɕAubN̓X^eBbN_AubNԂ̓_Ci~bN_
;	IN:		LED ij
;--------------------------------------------------------------------------------

BAR_DISPLAY:

	CALL	CLR_ALL_LED			; S

;
;	 1 ubN
;

LED1:							; 5Km/h 

	MOVLW	D'1'
	SUBWF	LED,W				; LED_IN - 1 -> W
	BTFSS	STATUS,C			; if LED_IN >= 1, C = 1
	GOTO	LED_BLOCK1

	BCF		LED01_PORT			; _i L = _j

LED2:							; 10Km/h 

	MOVLW	D'2'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK1

	BCF		LED02_PORT			; _i L = _j

LED3:							; 15Km/h 

	MOVLW	D'3'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK1

	BCF		LED03_PORT			; _i L = _j

LED4:							; 20Km/h 

	MOVLW	D'4'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK1

	BCF		LED04_PORT			; _i L = _j

LED5:							; 25Km/h 

	MOVLW	D'5'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK1

	BCF		LED05_PORT			; _i L = _j

LED6:							; 30Km/h 

	MOVLW	D'6'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK1

	BCF		LED06_PORT			; _i L = _j

LED7:							; 35Km/h 

	MOVLW	D'7'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK1

	BCF		LED07_PORT			; _i L = _j

LED8:							; 40Km/h 

	MOVLW	D'8'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK1

	BCF		LED08_PORT			; _i L = _j

LED_BLOCK1:

	CALL	PWM_BAR				; _ێ`

;
;	 2 ubN
;

LED9:							; 45Km/h 

	MOVLW	D'9'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK2

	BCF		LED09_PORT			; _i L = _j

LED10:							; 50Km/h 

	MOVLW	D'10'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK2

	BCF		LED10_PORT			; _i L = _j

LED11:							; 55Km/h 

	MOVLW	D'11'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK2

	BCF		LED11_PORT			; _i L = _j

LED12:							; 60Km/h 

	MOVLW	D'12'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK2

	BCF		LED12_PORT			; _i L = _j

LED13:							; 65Km/h 

	MOVLW	D'13'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK2

	BCF		LED13_PORT			; _i L = _j

LED14:							; 70Km/h 

	MOVLW	D'14'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK2

	BCF		LED14_PORT			; _i L = _j

LED15:							; 75Km/h 

	MOVLW	D'15'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK2

	BCF		LED15_PORT			; _i L = _j

LED16:							; 80Km/h 

	MOVLW	D'16'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK2

	BCF		LED16_PORT			; _i L = _j

LED_BLOCK2:

	CALL	PWM_BAR				; _ێ`

;
;	 3 ubN
;

LED17:							; 85Km/h 

	MOVLW	D'17'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK3

	BCF		LED17_PORT			; _i L = _j

LED18:							; 90Km/h 

	MOVLW	D'18'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK3

	BCF		LED18_PORT			; _i L = _j

LED19:							; 95Km/h 

	MOVLW	D'19'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK3

	BCF		LED19_PORT			; _i L = _j

LED20:							; 100Km/h sN

	MOVLW	D'20'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK3

	BCF		LED20_PORT			; _i L = _j

LED21:							; 105Km/h sN

	MOVLW	D'21'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK3

	BCF		LED21_PORT			; _i L = _j

LED22:							; 110Km/h sN

	MOVLW	D'22'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK3

	BCF		LED22_PORT			; _i L = _j

LED23:							; 115Km/h sN

	MOVLW	D'23'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK3

	BCF		LED23_PORT			; _i L = _j

LED24:							; 120Km/h 

	MOVLW	D'24'
	SUBWF	LED,W
	BTFSS	STATUS,C
	GOTO	LED_BLOCK3

	BCF		LED24_PORT			; _i L = _j

LED_BLOCK3:

	CALL	PWM_BAR				; _ێ`

	RETURN

;--------------------------------------------------------------------------------
;	S LED OFF
;--------------------------------------------------------------------------------

CLR_ALL_LED:

	MOVLW	B'11111111'			; BAR LEDA7 ZOƂ H = OFF

	MOVWF	PORTA				; (C1, C2)
	MOVWF	PORTC
	MOVWF	PORTD
	MOVWF	PORTE

CLR_7SEG:

	MOVLW	B'10000000'			; 7 ZO LED OFF
	MOVWF	PORTB				; C3  H = OFF

	BSF		C1_PORT
	NOP
	BSF		C2_PORT

	RETURN

;--------------------------------------------------------------------------------
;	TMR1 JEgl  g  xϊ
;
;	IN:			TMR1_CNT_H, TMR1_CNT_L
;	RETURN:		SPEEDi10iǒl Km/hj
;
;	NbN 4MHz, TMR1 vXP[ 8 ̏ꍇATMR1  8us  1 JEg
;	Ďg = 1000000us / ( 8us x TMR1 JEgl ) B
;	g = 125000 (16bit) / TMR1 JEgl (16bit) xmۂ̂ߎg10{ČvZ
;	x   = g x 10(16bit) x 1500(16bit) / 10000(16bit)  24bit ZɎ߂xグ
;--------------------------------------------------------------------------------

CONV_DATA:

	CLRF	SPEED			; ^C}l 0 ɔăNAĂ

	CLRF	B1
	MOVF	TMR1_CNT_H,W	; vZɊݏŏȂ悤lޔĂ
	MOVWF	B2				; B1B2B3 = 鐔
	MOVF	TMR1_CNT_L,W
	MOVWF	B3

	MOVF	B2,W			; JEg 0 (16bit) `FbN
	BTFSS	STATUS,Z
	GOTO	CONV_DATA2

	MOVF	B3,W
	BTFSC	STATUS,Z
	RETURN					; 鐔 = 0 Ȃ SPEED = 0 mȂ̂Ŗ߂

CONV_DATA2:

	MOVLW	FACTOR_H
	MOVWF	A1				; A1A2A3 = 鐔
	MOVLW	FACTOR_M
	MOVWF	A2
	MOVLW	FACTOR_L
	MOVWF	A3

	CALL	DIV24			; in Math24_v2.lib,  A1A2A3
							; ig x 10j 16bit ȓm A2A3

	CLRF	A1				; ŏ 8bit ͔Ô߃NA

	CLRF	B1				; ŏʂ̓NA
	MOVLW	H'05'			; 16bit͋
	MOVWF	B2
	MOVF	SP_FACTOR,W		; \x␳t@N^[ǂݏo
	MOVWF	B3

	CALL	MUL24			; in Math24_v2.lib,  A1A2A3B1B2B3 (48bit)
							; 16bit x 16bit Ȃ̂ŌIɂ͓ 32bit ɂȂ邪A
							;  200Km/h łg 4pXԂȂ 133Hz ɉ߂Ȃ̂ŁA
							; 133 x 10 x 1500 = 1995000  24bit ɏ\܂

	MOVF	B1,W			; 𕪎qɈړ
	MOVWF	A1
	MOVF	B2,W
	MOVWF	A2
	MOVF	B3,W
	MOVWF	A3

	CLRF	B1				; ꑤݒ
	MOVLW	H'27'			; &H2710 = 10000
	MOVWF	B2
	MOVLW	H'10'
	MOVWF	B3

	CALL	DIV24			; in Math24_v2.lib,  A1A2A3

	MOVF	A3,W			; A3 = ǑxB 8 bit ȓm
	MOVWF	SPEED

	RETURN

;--------------------------------------------------------------------------------
;	CM[lJE^̃Zbg
;--------------------------------------------------------------------------------

CLR_ILLE_CNT:

	MOVLW	ILLEGULAR_TH	; ̘ACM[lf[^XV邩
	MOVWF	ILLEGULAR

	RETURN

;--------------------------------------------------------------------------------
;	KΉ LED \ێi\tgEGA PWMj
;	IN:		BLIGHTNESS (l: 1 ` Kől)
;--------------------------------------------------------------------------------
;
;	7 ZO LED
;

PWM_7SEG:						; v 3.04ms

	BCF		PWM_MAX				; tONAĂ

	DECFSZ	BLIGHTNESS,W		; BLIGHTNESS = 1 ?
	GOTO	PWM_7SEG2			; NO

	MOVLW	D'2'				; NbsO
	GOTO	SET_BLT

PWM_7SEG2:

	MOVF	BLIGHTNESS,W		; Klǂݏo

SET_BLT:

	MOVWF	PWM_ON				; ON 񐔂Zbg

	SUBLW	DUTY_MAX			; Kől - ON (W) -> W
	MOVWF	PWM_OFF				; OFF 񐔂Zbg
	BTFSC	STATUS,Z
	BSF		PWM_MAX				; OFF = 0 Ȃ̂ōőPxtO𗧂Ă

;
;	LED ON 
;

PWM_7SEG3:

	CALL	WAIT_50us_4MHz		; _ĕێ
	CALL	WAIT_20us_4MHz
	CALL	WAIT_10us_4MHz

	DECFSZ	PWM_ON,F
	GOTO	PWM_7SEG3			;  ON

;
;	ON I
;

	CALL	CLR_ALL_LED			; LED 

	BTFSC	PWM_MAX				; őPx ?
	RETURN						; őȂI

;
;	LED OFF 
;

PWM_7SEG4:

	CALL	WAIT_50us_4MHz		; ̂܂܎Ԃ
	CALL	WAIT_20us_4MHz
	CALL	WAIT_10us_4MHz

	DECFSZ	PWM_OFF,F
	GOTO	PWM_7SEG4			;  OFF

	RETURN

;
;	o[ LED
;

PWM_BAR:						; v 2.08ms

PWM_BAR2:

	BCF		PWM_MAX				; tONAĂ

	MOVF	BLIGHTNESS,W		; Klǂݏo
	MOVWF	PWM_ON				; ON 񐔂Zbg

	SUBLW	DUTY_MAX			; Kől - ON (W) -> W
	MOVWF	PWM_OFF				; OFF 񐔂Zbg
	BTFSC	STATUS,Z
	BSF		PWM_MAX				; OFF = 0 Ȃ̂ōőPxtO𗧂Ă

;
;	LED ON 
;

PWM_BAR3:

	CALL	WAIT_50us_4MHz		; _ĕێ
	CALL	WAIT_10us_4MHz
	NOP							; 1us
	NOP							; 1us

	DECFSZ	PWM_ON,F
	GOTO	PWM_BAR3			;  ON

;
;	ON I
;

	CALL	CLR_ALL_LED			; LED 

	BTFSC	PWM_MAX				; őPx ?
	RETURN						; őȂ玞ԒׂŏI

;
;	LED OFF 
;

PWM_BAR4:

	CALL	WAIT_50us_4MHz		; _ĕێ
	CALL	WAIT_10us_4MHz
	NOP							; 1us
	NOP							; 1us

	DECFSZ	PWM_OFF,F
	GOTO	PWM_BAR4			;  OFF

	RETURN

;--------------------------------------------------------------------------------
;	邳`FbNA莞ԓԂpKύXiqXeVX@\j
;	RETURN		BLIGHTNESS (l: 1 ` Kől)
;--------------------------------------------------------------------------------

CHECK_DIMMER:

	BTFSC	DIMMER_PORT		; ݂̖邳`FbN
	GOTO	DARK			; H = 

BLIGHT:						; 

	CALL	RESET_DK_CNT	; ÃJE^Zbg

	DECFSZ	BL_CNT,F
	RETURN					; 񐔖̓`FbNp

	CALL	RESET_BL_CNT	; JE^Zbg

	INCF	BLIGHTNESS,F	; KiPxjUp

	MOVLW	DUTY_MAX + 1
	SUBWF	BLIGHTNESS,W	; BLIGHTNESS - Kől+1 -> W
	BTFSS	STATUS,C		; if BLIGHTNESS >= Kől+1, C=1, skip next line
	RETURN

	MOVLW	DUTY_MAX
	MOVWF	BLIGHTNESS		; KőlɏC

	RETURN

DARK:						; Ï

	CALL	RESET_BL_CNT	; JE^Zbg

	DECFSZ	DK_CNT,F
	RETURN					; 񐔖̓`FbNp

	CALL	RESET_DK_CNT	; ÃJE^Zbg

	DECFSZ	BLIGHTNESS,F	; KiPxjDown
	RETURN					; 0 ȊO OK

	INCF	BLIGHTNESS,F	; Kŏl (=1) ɏC

	RETURN

;--------------------------------------------------------------------------------
;	ÌoJE^̃Zbg
;--------------------------------------------------------------------------------

RESET_BL_CNT:

	MOVLW	RESPONSE
	MOVWF	BL_CNT
	RETURN

RESET_DK_CNT:

	MOVLW	RESPONSE
	MOVWF	DK_CNT
	RETURN

;--------------------------------------------------------------------------------
;	X^[gAbvf
;--------------------------------------------------------------------------------

START_UP:

	BCF		LED01_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED01_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED02_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED02_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED03_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED03_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED04_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED04_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED05_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED05_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED06_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED06_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED07_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED07_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED08_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED08_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED09_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED09_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED10_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED10_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED11_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED11_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED12_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED12_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED13_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED13_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED14_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED14_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED15_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED15_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED16_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED16_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED17_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED17_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED18_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED18_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED19_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED19_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED20_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED20_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED21_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED21_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED22_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED22_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED23_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED23_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED24_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED24_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED23_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED23_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED22_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED22_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED21_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED21_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED20_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED20_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED19_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED19_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED18_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED18_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED17_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED17_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED16_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED16_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED15_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED15_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED14_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED14_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED13_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED13_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED12_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED12_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED11_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED11_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED10_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED10_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED09_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED09_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED08_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED08_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED07_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED07_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED06_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED06_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED05_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED05_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED04_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED04_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED03_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED03_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED02_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED02_PORT			; 
	CALL	HOLD_BAR2

	BCF		LED01_PORT			; _i L = _j
	CALL	HOLD_BAR1			; LED _΂炭z[h
	BSF		LED01_PORT			; 
	CALL	HOLD_BAR2

	CALL	CLR_ALL_LED			; Ô

	RETURN

;--------------------------------------------------------------------------------
;	X^[gAbvf LED \ێ
;--------------------------------------------------------------------------------

HOLD_BAR1:

	CALL	WAIT_10ms_4MHz
	RETURN

HOLD_BAR2:

	CALL	WAIT_2ms_4MHz
	RETURN

;--------------------------------------------------------------------------------
;	Cuǂݍ
;--------------------------------------------------------------------------------

	INCLUDE		Wait.lib		; ԑ҂[vCu
	INCLUDE		Math24-v2.lib	; 24bit lZCu

;--------------------------------------------------------------------------------
;	vOI
;--------------------------------------------------------------------------------

	END
